#import <Foundation/Foundation.h>
#import "Apple80211.h"

#define VERSION "0.1"

int main (int argc, const char * argv[]) {
    if(argc != 3) {
        printf("Translate a string into a 40 or 104-bit Apple hashed WEP key.\n");
        printf("usage: %s <password> <use104bits>\n", argv[0]);
        printf("\tpassword:\tthe ASCII WEP password\n");
        printf("\tuse104bits:\t0 for 40 bit key and 1 for 104 bit key \n");
		printf("\tversion: %s\n", VERSION);    
        return 1;
    }
    
    WirelessKey wepKey;
    UInt32 use104bits = (strcmp(argv[2], "1") == 0);

	CFStringRef password = CFStringCreateWithCString(kCFAllocatorDefault, argv[1], kCFStringEncodingISOLatin1);
    
	WIErr wiError;
    wiError = WirelessEncrypt(password, &wepKey, use104bits);
    
	if(wiError != noErr) {
		printf("Error %d\n", wiError);
		return 1;
	}

    int i;
    for(i=0; i <= 12; i++)
        printf("%.2X", wepKey[i]);
    printf("\n");
    
    CFRelease(password);

    return 0;
}
